import * as React from 'react';
import { PropTypes } from '@cloudflare/types';
import { Div } from '@cloudflare/elements';

export interface ICheckboxProps {
  name: string;
  value: string;
  label: string | boolean | React.ReactNode;
  // Don't need checked or onchage when managed by a checkbox group
  checked?: boolean;
  onChange?: React.ChangeEventHandler<HTMLInputElement>;
  disabled?: boolean;
  type?: string;
  indeterminate?: boolean;
  testId?: string;
  spacing?: number;
}
export class Checkbox extends React.Component<
  ICheckboxProps & Omit<PropTypes<typeof Div>, keyof ICheckboxProps>
> {}

export class CheckboxGroup extends React.Component<{
  values: string[];
  disabled?: boolean;
  unwrap?: boolean;
  onChange: (e: string[]) => void;
}> {}
